#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

const int N = 500001, inf = 1e8 + 7;

int n, m;

vector <char> v[N], g[N];
vector <int> v1[N], v2[N], g1[N], g2[N];

int ab(int t){
    if (t >= 0)
        return t;
    return -t;
}

int main()
{
    freopen("input.txt", "r", stdin);
    cin >> n >> m;
    for (int i = 1; i <= n; i++){
        g[i].resize(m + 1);
        g1[i].resize(m + 1);
        g2[i].resize(m + 1);
        g[i][0] = '#';
    }
    for (int j = 1; j <= m; j++){
        v[j].resize(n + 1);
        v1[j].resize(n + 1);
        v2[j].resize(n + 1);
            v[j][0] = '#';
    }
    for (int i = 1; i <= n; i++)
    for (int j = 1; j <= m; j++){
        char c;
        cin >> c;
        g[i][j] = c;
        v[j][i] = c;
    }
    for (int i = 1; i <= n; i++){
        int p1 = 0, p2 = 0;
        char c1 = '1', c2 = '2';
        for (int k = 1; k <= m; k++){
            g1[i][k] = p1;
            g2[i][k] = p2;
            if (g[i][k] == c1)
                p1 = k;
            else{
                p2 = k;
                swap(p1, p2);
                swap(c1, c2);
            }
        }
        p1 = 0, p2 = 0;
        c1 = '1', c2 = '2';
        for (int k = m; k >= 1; k--){
            if (p1 != 0 && g1[i][k] != c1 && (g2[i][k] == 0 || ab(k - p1) < ab(k - g2[i][k])))
                g2[i][k] = p1;
            if (g1[i][k] == 0 || (g2[i][k] != 0 && ab(k - g1[i][k]) > ab(k - g2[i][k])))
                swap(g1[i][k], g2[i][k]);
            if (p2 != 0 && g1[i][k] != c2 && (g2[i][k] == 0 || ab(k - p2) < ab(k - g2[i][k])))
                g2[i][k] = p2;
            if (g[i][k] == c1)
                p1 = k;
            else{
                p2 = k;
                c2 = g[i][k];
                swap(p1, p2);
                swap(c1, c2);
            }
        }
    }
   for (int j = 1; j <= m; j++){
        int p1 = 0, p2 = 0;
        char c1 = '1', c2 = '2';
        for (int k = 1; k <= n; k++){
            v1[j][k] = p1;
            v2[j][k] = p2;
            if (v[j][k] == c1)
                p1 = k;
            else{
                p2 = k;
                swap(p1, p2);
                swap(c1, c2);
            }
        }
        p1 = 0, p2 = 0;
        c1 = '1', c2 = '2';
        for (int k = n; k >= 1; k--){
            if (p1 != 0 && v1[j][k] != c1 && (v2[j][k] == 0 || ab(k - p1) < ab(k - v2[j][k])))
                v2[j][k] = p1;
            if (v1[j][k] == 0 || (v2[j][k] != 0 && ab(k - v1[j][k]) > ab(k - v2[j][k])))
                swap(v1[j][k], v2[j][k]);
            if (p2 != 0 && v1[j][k] != c2 && (v2[j][k] == 0 || ab(k - p2) < ab(k - v2[j][k])))
                v2[j][k] = p2;
            if (v[j][k] == c1)
                p1 = k;
            else{
                p2 = k;
                c2 = v[j][k];
                swap(p1, p2);
                swap(c1, c2);
            }
        }
    }
    int q;
    cin >> q;
    for (; q > 0; q--){
        int r1, c1, r2, c2, ar1, ac1, ar2, ac2, ans = inf;
        cin >> r1 >> c2;

        c1 = g1[r1][c2];
        r2 = v1[c2][r1];
        if (c1 != 0 && r2 != 0 && g[r1][c1] != g[r2][c2] && ab(r1 - r2) + ab(c1 - c2) < ans){
            ans = ab(r1 - r2) + ab(c1 - c2);
            ar1 = r1;
            ac1 = c1;
            ar2 = r2;
            ac2 = c2;
        }

        c1 = g2[r1][c2];
        r2 = v1[c2][r1];
        if (c1 != 0 && r2 != 0 && g[r1][c1] != g[r2][c2] && ab(r1 - r2) + ab(c1 - c2) < ans){
            ans = ab(r1 - r2) + ab(c1 - c2);
            ar1 = r1;
            ac1 = c1;
            ar2 = r2;
            ac2 = c2;
        }

        c1 = g1[r1][c2];
        r2 = v2[c2][r1];
        if (c1 != 0 && r2 != 0 && g[r1][c1] != g[r2][c2] && ab(r1 - r2) + ab(c1 - c2) < ans){
            ans = ab(r1 - r2) + ab(c1 - c2);
            ar1 = r1;
            ac1 = c1;
            ar2 = r2;
            ac2 = c2;
        }

        c1 = g2[r1][c2];
        r2 = v2[c2][r1];
        if (c1 != 0 && r2 != 0 && g[r1][c1] != g[r2][c2] && ab(r1 - r2) + ab(c1 - c2) < ans){
            ans = ab(r1 - r2) + ab(c1 - c2);
            ar1 = r1;
            ac1 = c1;
            ar2 = r2;
            ac2 = c2;
        }
        if (ans != inf)
            cout << ar1 << ' ' << ac1 << ' ' << ar2 << ' ' << ac2 << endl;
        else
            cout << -1 << endl;
    }
    return 0;
}
