#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef double ld;

const int MAX = 12;

int dist[MAX];
vector<int> vec[MAX];
int to[MAX];

int n, m;
const int INF = 1e9;
bitset<MAX> d[MAX];
bitset<MAX> empty, q;
bitset<MAX> t[MAX];
void dfs(int pos) {
	for (int i = 1; i <= n + m; i++)
		dist[i] = INF;
	dist[pos] = 1;
	set<pair<int, int> > s;
	s.insert(make_pair(1, pos));
	while (!s.empty()) {
		int pos = s.begin()->second;
		int d = s.begin()->first;
		s.erase(s.begin());
		for (int to : vec[pos]) {
			if (d + ::to[to] < dist[to]) {
				if (dist[to] != INF)
					s.erase(make_pair(dist[to], to));
				dist[to] = d + ::to[to];
				s.insert(make_pair(dist[to], to));
			}
		}
	}
	dist[pos] = 0;
	for (int i = 1; i <= n; i++) {
		cout << (dist[i] == INF ? -1 : dist[i]) << " ";
	}
	cout << endl;
}

void dfs(bitset<MAX> used) {
	int s = used.count();
	for (int i = 1; i <= n; i++) {
		if (used[i]) {
			dist[i] = min(dist[i], s);
			for (int g : vec[i]) {
				bitset<MAX> h = (used | t[g - n]);
				//cout << h << " " << used << " " << t[g] << " " << g << endl;
				if ((int) h.count() != s) {
					dfs(h);
				}
			}
		}
	}
}

void make(int pos) {
	for (int i = 1; i <= n; i++)
		dist[i] = INF;
	bitset<MAX> t;
	t[pos] = true;
	dfs(t);
	dist[pos] = 0;
	for (int i = 1; i <= n; i++)
		if (dist[i] == INF)
			dist[i] = -1;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	srand(time(NULL));
	cout.precision(10);
#if __cplusplus == 201103
	freopen("input.txt", "r", stdin);
#else

#endif

	cin >> n >> m;
	assert(1 <= n && n <= 300 && 1 <= m && m <= 300);
	for (int i = 1; i <= n; i++) {
		int k;
		cin >> k;
		vector<bool> used(m + 1);
		used[0] = true;
		while (k--) {
			int a = 0;
			cin >> a;
			used[a] = true;
			t[a][i] = true;
			t[a + n][i] = true;
			//assert(a > last);
			//last = a;
			a += n;
			vec[i].push_back(a);
			vec[a].push_back(i);
			to[a]++;
		}
	}

	for (int i = n + 1; i <= n + m; i++)
		to[i]--;
	if (n <= 14) {
		for (int j = 1; j <= n; j++) {
			make(j);
			for (int i = 1; i <= n; i++) {
				cout << dist[i] << " ";
			}
			cout << endl;
		}
	} else {
		for (int j = 1; j <= n; j++)
			dfs(j);
	}

}
