#include <bits/stdc++.h>

using namespace std;

#define endl '\n'
#define fi first
#define se second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)(x).size()

typedef long long llong;

const int MAX_M = 1000000, MAX_K = 1000000;

struct Step {
    int n, m, id;
    bool isExit;

    Step() {
        this->n = 0;
        this->m = 0;
        this->id = 0;
        this->isExit = false;
    }

    Step(int n, int m, int id, bool isExit) {
        this->n = n;
        this->m = m;
        this->id = id;
        this->isExit = isExit;
    }

    friend bool operator < (const Step& a, const Step& b) {
        if (a.n < b.n) {
            return true;
        }

        if (a.n > b.n) {
            return false;
        }

        if (a.isExit && !b.isExit) {
            return true;
        }

        if (!a.isExit && b.isExit) {
            return false;
        }

        return a.id < b.id;
    }
};

int n, m, k, playses[MAX_K + 1];

bool isStand[MAX_K + 1];

long long ans[MAX_M + 1];

set<Step> steps;
set<int> freeStand, freeSeat;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    if (0)
        freopen("input.txt", "r", stdin);

    cin >> n >> m >> k;

    int a, b;
    for (int i = 1; i <= k; i++) {
        cin >> a >> b;

        steps.insert(Step(a, b, i, false));
        steps.insert(Step(b, a, i, true));
    }

    for (int i = 1; i < m; i++) {
        freeSeat.insert(i);
        freeStand.insert(i);
    }
    freeStand.insert(m);

    for (auto i: steps) {
        if (!i.isExit) {
            if (freeSeat.empty()) {
                if (freeStand.empty()) {
                    playses[i.id] = -1;
                } else {
                    playses[i.id] = *freeStand.begin();
                    isStand[i.id] = true;
                    freeStand.erase(freeStand.begin());
                    ans[playses[i.id]] += i.m - i.n;
                }
            } else {
                playses[i.id] = *freeSeat.begin();
                isStand[i.id] = false;
                freeSeat.erase(freeSeat.begin());
            }
        } else {
            if (playses[i.id] == -1) {
                continue;
            }

            if (isStand[i.id]) {
                freeStand.insert(playses[i.id]);
            } else {
                freeSeat.insert(playses[i.id]);
            }
        }
    }

    long long ans1 = ans[1], ans2 = 1;
    for (int i = 2; i <= m; i++) {
        if (ans[i] < ans1) {
            ans1 = ans[i];
            ans2 = i;
        }
    }
    cout << ans1 << ' ' << ans2 << endl;

    return 0;
}
