#include <iostream>
#include <cstdio>
#include <vector>
#include <string>
#include <set>
#include <algorithm>

using namespace std;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	
	int n, m, k;
	scanf("%d%d%d", &n, &m, &k);

	vector<pair<int, int>> a(k);
	for (int i = 0; i < k; ++i) {
		scanf("%d%d", &a[i].first, &a[i].second);
	}
	int fr = m - 1;
	vector<int> ans(m);

	struct Event {
		int type, pos, id;

		bool operator<(const Event &e) {
			return pos != e.pos ? pos < e.pos : type != e.type ? type < e.type : id < e.id;
		}
	};
	vector<Event> es;

	for (int i = 0; i < k; ++i) {
		es.push_back(Event{ 1, a[i].first, i }); 
		es.push_back(Event{ -1, a[i].second, i });
	}

	sort(es.begin(), es.end());

	set<int> fr_up;
	vector<int> used(k, -1);

	for (int i = 0; i < m; ++i){
		fr_up.insert(i);
	}

	for (auto e : es) {
		if (e.type == 1) {
			if (fr == 0 && fr_up.empty()) continue;
			if (fr) {
				fr--;
			}
			else {
				int pl = *fr_up.begin();
				fr_up.erase(fr_up.begin());
				ans[pl] += a[e.id].second - a[e.id].first;
				used[e.id] = pl;
			}
		}
		else {
			int pl = used[e.id];
			if (pl == -1) fr++;
			else fr_up.insert(pl);
		}
    }

	int mn_id = 0, mn = ans[0];
	for (int i = 0; i < m; ++i) {
		if (mn > ans[i]) {
			mn_id = i;
			mn = ans[i];
		}
	}
	cout << mn << ' ' << mn_id + 1;
	return 0;
}