#include <iostream>
#include <string>
#include <vector>

using namespace std;

char buf[(int)1e6 + 200];

struct Node {
	bool isleaf;
	vector<int> go;
	vector<vector<int>> undone;

	Node() {
		go.assign(26, -1);
		undone.resize(26);
		isleaf = 0;
	}
};

struct Query {
	string s;
	int pos;
	int id;
};


vector<Node> trie;
vector<Query> incomp;

pair<int, int> build(const string &q) {
	int divide = -1, depth = 0;
	int cur = 0;
	for (int i = 0; i < q.length(); ++i) {
		if (trie[cur].go[q[i] - 'a'] != -1) {
			cur = trie[cur].go[q[i] - 'a'];
		}
		else {
			if (divide == -1) divide = cur, depth = i;
			Node nd = Node();
			trie.push_back(nd);
			trie[cur].go[q[i] - 'a'] = (int)trie.size() - 1;
			cur = (int)trie.size() - 1;
		}
	}

	trie[cur].isleaf = 1;

	return{ divide, depth };
}

int push(Query &q, int cur, int id) {
	for (int &j = q.pos; j < q.s.length(); ++j) {
		if (trie[cur].go[q.s[j] - 'a'] != -1) {
			cur = trie[cur].go[q.s[j] - 'a'];
			if (trie[cur].isleaf) cur = 0;
		}
		else {
			trie[cur].undone[q.s[j] - 'a'].push_back(id);
			break;
		}
	}
	return q.pos;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n;
	scanf("%d", &n);

	trie.push_back(Node());

	int lastk = 0;

	for (int i = 0; i < n; i++) {
		char type;
		scanf(" %c %s", &type, buf);

		vector<int> done;
        
		if (type == '+') {
			string tmp = string(buf);

			lastk %= tmp.length();
			tmp = tmp.substr(lastk) + tmp.substr(0, lastk);
			cerr << tmp << endl;

			pair<int, int> res = build(tmp);
			int div = res.first, pos = res.second;

			int c = tmp[pos] - 'a';
			while (!trie[div].undone[c].empty()) {
				int back = trie[div].undone[c].back();
				trie[div].undone[c].pop_back();

				push(incomp[back], div, back);
				if (incomp[back].pos == incomp[back].s.length()) done.push_back(incomp[back].id);
			}
		}
		else {
			Query q;
			string tmp = string(buf);

			lastk %= tmp.length();
			tmp = tmp.substr(lastk) + tmp.substr(0, lastk);
			cerr << tmp << endl;
            
			q.s = tmp;
			q.pos = 0;
			q.id = incomp.size();
			incomp.push_back(q);
            
			push(incomp.back(), 0, incomp.size() - 1);

			if (incomp.back().pos == q.s.length()) done.push_back(incomp.size() - 1);
		}

		cout << done.size() << ' ';
		for (int j = 0; j < done.size(); ++j)
			cout << done[j] + 1 << ' ';
	    cout << '\n';
		lastk = done.size();
	}
    

	return 0;
}