#include <iostream>
#include <vector>
#include <algorithm>

#define fi first
#define se second
using namespace std;
typedef long long ll;

const int N = 3e5;

int d[N]; // start
const int inf = 1e9;
int t[4 * N];

void update(int v, int l, int r, int pos, int x) {
	if (pos < l || pos >= r) return;
	if (l == r - 1) {
		t[v] = x;
		return;
	}
	int m = (l + r) >> 1;
	update(2 * v + 1, l, m, pos, x);
	update(2 * v + 2, m, r, pos, x);
	t[v] = min(t[2 * v + 1], t[2 * v + 2]);
}

int get(int v, int l, int r, int L, int R) {
	if (l >= R || r <= L) return inf;
	if (l >= L && r <= R) return t[v];
	int m = (l + r) >> 1;
	return min(get(2 * v + 1, l, m, L, R), get(2 * v + 2, m, r, L, R));
}



int main() {
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(false);

	int n, m, k;
	cin >> n >> k >> m;

	vector <int> a(m);
	for (int i = 0; i < m; i++) cin >> a[i];
	sort(a.begin(), a.end());

	for (int i = 0; i < N; i++) d[i] = inf;
	for (int i = 0; i < 4 * N; i++) t[i] = inf;

	// d - end
	// t - start, tree

	for (int i = 0; i < m; i++) {

		//  
		int mn = inf;
		if (i) mn = d[i - 1];
		if (!i) mn = 0;


		int L, R; //

		int l = -1, r = i;
		if (i) {
			while (l != r - 1) {
				int mid = (l + r) >> 1;
				if (a[mid] + k - 1 < a[i - 1]) l = mid;
				else r = mid;
			}
			L = r;
		}
		else {
			L = r + 1;
		}

		l = -1, r = i;
		while (l < r - 1) {
			int mid = (l + r) >> 1;
			if (a[mid] + k - 1 < a[i]) l = mid;
			else r = mid;
		}
		R = l;

		if (L <= R) {
			mn = min(mn, get(0, 0, m, L, R + 1));
			update(0, 0, m, i, mn + min(n, a[i] + k - 1) - a[i] + 1);
		}
		else {
			update(0, 0, m, i, mn + min(n, a[i] + k - 1) - a[i] + 1);
		}


		l = -1, r = i;
		while (l < r - 1) {
			int mid = (l + r) >> 1;
			if (a[i] - k + 1 > a[mid]) l = mid;
			else r = mid;
		}
		mn = inf;
		if (l == -1) mn = 0;
		if (l != -1) {
			mn = d[l];

			// L , R
			int it = l;

			l = -1, r = i;
			while (l < r - 1) {
				int mid = (l + r) >> 1;
				if (a[mid] + k - 1 >= a[it]) r = mid;
				else l = mid;
			}
			L = r;

			l = -1, r = i;
			while (l < r - 1) {
				int mid = (l + r) >> 1;
				if (a[mid] + k - 1 >= a[it + 1]) r = mid;
				else l = mid;
			}
			R = l;

			if (L <= R) {
				mn = min(mn, get(0, 0, m, L, R + 1));
			}
		}
		d[i] = mn + a[i] - max(1, a[i] - k + 1) + 1;
	}

	int ans = d[m - 1];

	for (int i = 0; i < m; i++) {
		if (a[i] + k - 1 >= a[m - 1]) ans = min(ans, get(0, 0, m, i, i + 1));
	}

	cout << n - ans << endl;

}
