#include <bits/stdc++.h>

using std::cerr;
using std::cin;
using std::cout;

using std::abs;
using std::min;
using std::max;
using std::swap;

using std::map;
using std::pair;
using std::set;
using std::string;
using std::vector;

using ll = long long;
using uint = unsigned int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define ff first
#define ss second
#define pb emplace_back
#define sqr(x) ((x)*(x))
#ifdef LOCAL
#define dbg(as...) { \
    vector<string> _v;\
    std::stringstream _ss(#as);\
    string _cur, _loc;\
    while (getline(_ss, _cur, ',')) {\
        while(count(_cur.begin(), _cur.end(), '(') != count(_cur.begin(), _cur.end(), ')')) {\
            getline(_ss, _loc, ',');\
            _cur += "," + _loc;\
        }\
        _v.pb(_cur);\
    }\
    err(_v.begin(),as);\
}
#else
#define dbg(as...)
#endif // LOCAL

template<typename T>
void err(vector<string>::iterator it, T a) {
    cerr << (it->substr((*it)[0] == ' ')) << " = " << a << '\n';
    err(++it, a);
}
template<typename T, typename...Ts>
void err(vector<string>::iterator it, T a, Ts...as) {
    cerr << (it->substr((*it)[0] == ' ')) << " = " << a << '\n';
    err(++it, as...);
}

struct init{
    init() {
        cin.tie(0);
        std::iostream::sync_with_stdio(0);
        cerr << std::fixed << std::setprecision(10);
        cout << std::fixed << std::setprecision(10);
        srand(300);
    }
    ~init() {
        cerr << "Time : " << 1.0 * clock() / CLOCKS_PER_SEC << " s.\n";
    }
};

struct ev{
    int x, y, num;
    ev(int _x, int _y, int _num) : x(_x), y(_y), num(_num){} ;
};

const int MAXN = 2e5 + 1;
bool ok[MAXN];

int main() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<ev> evs;
    for (int i = 0; i < k; ++i) {
        int a, b;
        cin >> a >> b;
        evs.pb(a, 1, i);
        evs.pb(b, -1, i);
    }

    sort(evs.begin(), evs.end(), [](const ev & p1, const ev & p2) {
            return p1.x == p2.x ? p1.y < p2.y : p1.x < p2.x;
    });

    int cnt = 1;
    int prev = 0;
    int ans = 0;
    for (ev p : evs) {
        if (p.y == -1 && ok[p.num]) {
            --cnt;
        } else if (p.y == 1) {
            if (cnt != m + m) {
                ++cnt;
                ok[p.num] = true;
            }
        }
        if (cnt == m + m)
            ans += p.x - prev;
        prev = p.x;
    }

    cout << ans << ' ' << m << '\n';

    return 0;
}
