#include <bits/stdc++.h>

using std::cerr;
using std::cin;
using std::cout;

using std::abs;
using std::min;
using std::max;
using std::swap;

using std::map;
using std::pair;
using std::set;
using std::string;
using std::vector;

using ll = long long;
using uint = unsigned int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define ff first
#define ss second
#define pb emplace_back
#define sqr(x) ((x)*(x))
#ifdef LOCAL
#define dbg(as...) { \
    vector<string> _v;\
    std::stringstream _ss(#as);\
    string _cur, _loc;\
    while (getline(_ss, _cur, ',')) {\
        while(count(_cur.begin(), _cur.end(), '(') != count(_cur.begin(), _cur.end(), ')')) {\
            getline(_ss, _loc, ',');\
            _cur += "," + _loc;\
        }\
        _v.pb(_cur);\
    }\
    err(_v.begin(),as);\
}
#else
#define dbg(as...)
#endif // LOCAL

template<typename T>
void err(vector<string>::iterator it, T a) {
    cerr << (it->substr((*it)[0] == ' ')) << " = " << a << '\n';
    err(++it, a);
}
template<typename T, typename...Ts>
void err(vector<string>::iterator it, T a, Ts...as) {
    cerr << (it->substr((*it)[0] == ' ')) << " = " << a << '\n';
    err(++it, as...);
}

struct init{
    init() {
        cin.tie(0);
        std::iostream::sync_with_stdio(0);
        cerr << std::fixed << std::setprecision(10);
        cout << std::fixed << std::setprecision(10);
        srand(300);
    }
    ~init() {
        cerr << "Time : " << 1.0 * clock() / CLOCKS_PER_SEC << " s.\n";
    }
} init;

const int  MAXA = 26;

int main() {
//    dbg(1000000 * 26 * 4 * 6, 1000000 * 26 * 4 * 2);
    int n, m;
    cin >> n >> m;
    vector<vector<char>> f(n + 2);
    vector<vector<vector<int>>> up(n + 2, vector<vector<int>>(MAXA));
    vector<vector<vector<int>>> left(n + 2, vector<vector<int>>(MAXA));
    for (int i = 1; i <= n; ++i) {
        f[i].resize(m + 2);
        for (int j = 1; j <= m; ++j)
            cin >> f[i][j];
        for (int c= 0; c < MAXA; ++c) {
            left[i][c].resize(m + 2);
            up[i][c].resize(m + 2);
            {int prev = -1;
            for (int j = 1; j <= m; ++j) {
                left[i][c][j] = prev;
                if (f[i][j] == c + 'a')
                    prev = j;
            }}
            {int prev = -1;
            for (int j = m; j >= 1; --j) {
                int right = prev;
                if (f[i][j] == c + 'a')
                    prev = j;
                if (left[i][c][j] == -1)
                    left[i][c][j] = right;
                else if(right == -1)
                    left[i][c][j] = left[i][c][j];
                else
                    left[i][c][j] = j - left[i][c][j] < right - j ? left[i][c][j] : right;
            }}
        }
    }

    for (int j = 1; j <= m; ++j) {
        for (int c= 0; c < MAXA; ++c) {
            {
                int prev = -1;
                for (int i = 1; i <= n; ++i) {
                    up[i][c][j] = prev;
                    if (f[i][j] == c + 'a')
                        prev = i;
                }
            }
            {
                int prev = -1;
                for (int i = n; i >= 1; --i) {
                    int down = prev;
                    if (f[i][j] == c + 'a')
                        prev = i;
                    if (up[i][c][j] == -1)
                        up[i][c][j] = down;
                    else if (down == -1)
                        up[i][c][j] = up[i][c][j];
                    else
                        up[i][c][j] = i - up[i][c][j] < down - i ? up[i][c][j]  : down;
                }
            }
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int x, y;
        cin >> x >> y;
        int mn = 1e9, wc1, wc2;
        for (int c1 = 0; c1 < MAXA; ++c1) {
            for (int c2 = c1 + 1; c2 < MAXA; ++c2) {
                    if (left[x][c1][y] != -1 && up[x][c2][y] != -1){
                        int pot = abs(left[x][c1][y] - y) + abs(up[x][c2][y] - x);
                        if (mn > pot) {
                            mn = pot;
                            wc1 = c1;
                            wc2 = c2;
                        }
                    }
                    if (left[x][c2][y] != -1 && up[x][c1][y] != -1) {
                        int pot = abs(left[x][c2][y] - y) + abs(up[x][c1][y] - x);
                        if (mn > pot) {
                            mn = pot;
                            wc1 = c2;
                            wc2 = c1;
                        }
                    }
            }
        }
        if (mn == 1e9)
            cout << "-1\n";
        else
            cout << x << ' ' << left[x][wc1][y] << ' ' << up[x][wc2][y] << ' ' << y << '\n';
    }

    return 0;
}
