#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <deque>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 1e5;
const ll LINF = 1e18 + 1e15;
const ld EPS = 1e-7;
const ll MOD = 1e9 + 7;
set<ll> freesit;
set<ll> freestand;
vector<pair<ll, ll>> mas;
vector<pair<pair<ll, bool>, ll>> qs;
vector<ll> anscnt;
vector<pair<bool, ll>> position;

int run() {
	ll n, m, k;
	cin >> n >> m >> k;
	for (int i = 0; i < m; i++) {
		freesit.insert(i);
		freestand.insert(i);
	}
	freesit.erase(m - 1);
	anscnt.resize(m, 0);
	position.resize(k, make_pair(false, -1));
	mas.resize(k);
	for (int i = 0; i < k; i++) {
		cin >> mas[i].first >> mas[i].second;
		qs.push_back(make_pair(make_pair(mas[i].first, true), i));
		qs.push_back(make_pair(make_pair(mas[i].second, false), i));
	}
	sort(qs.begin(), qs.end());
	for (int i = 0; i < qs.size(); i++) {
		if (!qs[i].first.second) { // remove
			bool issit = position[qs[i].second].first;
			ll pos = position[qs[i].second].second;
			if (pos == -1) continue;
			if (issit) {
				freesit.insert(pos);
			}
			else {
				freestand.insert(pos);
			}
			position[qs[i].second].second = -1;
		}
		else { // add
			if (!freesit.empty()) {
				position[qs[i].second].first = true;
				position[qs[i].second].second = *freesit.begin();
				freesit.erase(freesit.begin());
			}
			else if(!freestand.empty()) {
				position[qs[i].second].first = false;
				position[qs[i].second].second = *freestand.begin();
				anscnt[*freestand.begin()] += mas[qs[i].second].second - mas[qs[i].second].first;
				freestand.erase(freestand.begin());
			}
		}
	}
	ll ans = 0;
	for (int i = 0; i < m; i++) {
		if (anscnt[i] < anscnt[ans]) ans = i;
	}
	cout << anscnt[ans] << " " << ans + 1;
	return 0;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nok";
	while (1);
#endif
	return 0;
}