#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <deque>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 1e5;
const ll LINF = 1e18 + 1e15;
const ld EPS = 1e-7;
const ll MOD = 1e9 + 7;
const ll MAXN = 5100;

int mas[MAXN][MAXN];

int run() {
	ll h, w, n;
	cin >> h >> w >> n;
	for (int i = 0; i < h; i++) {
		for (int j = 0; j < w; j++) {
			mas[i][j] = i*w + j;
		}
	}
	vector<ll> a(n);
	vector<ll> b(n);
	vector<ll> c(n);
	vector<ll> d(n);
	string s;
	cin >> s;
	ll k;
	cin >> k;
	for (int i = 0; i < k; i++) cin >> a[i];
	for (int i = k; i < n; i++) {
		a[i] = (10007 * a[i - 2] + 10009 * a[i - 1] + 87277) % h;
	}
	cin >> k;
	for (int i = 0; i < k; i++) cin >> b[i];
	for (int i = k; i < n; i++) {
		b[i] = (10007 * b[i - 2] + 10009 * b[i - 1] + 87277) % w;
	}
	cin >> k;
	for (int i = 0; i < k; i++) cin >> c[i];
	for (int i = k; i < n; i++) {
		c[i] = (10007 * c[i - 2] + 10009 * c[i - 1] + 87277) % h;
	}
	cin >> k;
	for (int i = 0; i < k; i++) cin >> d[i];
	for (int i = k; i < n; i++) {
		d[i] = (10007 * d[i - 2] + 10009 * d[i - 1] + 87277) % w;
	}
	vector<ll> perw(w);
	vector<ll> perh(h);
	for (int i = 0; i < w; i++) perw[i] = i;
	for (int i = 0; i < h; i++) perh[i] = i;
	for (int i = 0; i < n; i++) {
		char cc = s[i];
		if (cc == 'c') {
			ll p1 = b[i];
			ll p2 = d[i];
			swap(perw[p1], perw[p2]);
#ifdef _DEBUG
			cerr << cc << " " << p1 << " " << p2 << endl;
#endif
		}
		else if (cc == 'r') {
			ll p1 = a[i];
			ll p2 = c[i];
			swap(perh[p1], perh[p2]);
#ifdef _DEBUG
			cerr << cc << " " << p1 << " " << p2 << endl;
#endif
		}
		else {
			ll x1 = perh[a[i]];
			ll y1 = perw[b[i]];
			ll x2 = perh[c[i]];
			ll y2 = perw[d[i]];
			swap(mas[x1][y1], mas[x2][y2]);
#ifdef _DEBUG
			cerr << cc << " " << a[i] << " " << b[i] << " " << c[i] << " " << d[i] << endl;
			cerr << "is " << x1 << " " << y1 << " " << x2 << " " << y2 << endl;
#endif
		}
	}
	ll ans = 0;
	ll s17 = 1;
	ll s19 = 1;
	for (int i = 0; i < h; i++) {
		for (int j = 0; j < w; j++) {
			ans += mas[perh[i]][perw[j]] % MOD * s17 % MOD * s19 % MOD;
			ans %= MOD;
			s19 *= 19LL;
			s19 %= MOD;
		}
		s17 *= 17LL;
		s17 %= MOD;
		s19 = 1;
	}
	cout << ans;
	return 0;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nok";
	while (1);
#endif
	return 0;
}