#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <deque>
#include <queue>
#include <cassert>
#include <bitset>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 1e5;
const ll LINF = 1e18 + 1e15;
const ld EPS = 1e-7;
const ll MOD = 1e9 + 7;

const int N = 302;

#define base bitset<N>

int n, k;
base know[N];
base dp[N][N];
int best[N][N];

int run() {
	for (int i = 0; i < N; i++) {
		for (int j = 0; j < N; j++) {
			best[i][j] = -1;
		}
	}

	cin >> n >> k;
	for (int i = 0; i < n; i++) {
		int cnt;
		cin >> cnt;
		for (int j = 0; j < cnt; j++) {
			int id;
			cin >> id;
			id--;
			know[id][i] = 1;
		}
	}

	for (int iter = 0; iter < 5; iter++) {
		vector<int> p;
		for (int i = 0; i < n; i++) {
			p.push_back(i);
		}
		random_shuffle(p.begin(), p.end());

		for (int i = 0; i < N; i++) {
			for (int j = 0; j < N; j++) {
				for (int k = 0; k < N; k++) {
					if (i != j) dp[p[i]][p[j]][p[k]] = 1;
				}
			}
		}

		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				for (int c = 0; c < k; c++) {
					if (know[c][p[i]] && know[c][p[j]]) {
						if (dp[p[i]][p[j]].count() >= know[c].count()) {
							dp[p[i]][p[j]] = know[c];
						}
					}
				}
			}
		}

		for (int k = 0; k < n; k++) {
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) {
					auto t = (dp[p[i]][p[k]] | dp[p[k]][p[j]]);
					if (t.count() <= dp[p[i]][p[j]].count()) {
						dp[p[i]][p[j]] = t;
					}
				}
			}
		}

		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (!dp[p[i]][p[j]][N - 1]) {
					int cur = dp[p[i]][p[j]].count();
					if (best[p[i]][p[j]] == -1 || best[p[i]][p[j]] > cur) {
						best[p[i]][p[j]] = cur;
					}
				}
			}
		}
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			cout << best[i][j] << " ";
		}
		cout << "\n";
	}

	return 0;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nok";
	while (1);
#endif
	return 0;
}