#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <utility>
#include <fstream>
#include <sstream>

using namespace std;

const long long LINF = 3e18;
const int maxN = 2e5 + 1000;

int fw[2][maxN];
int pos[maxN];
int row[maxN];
int sum[maxN];

int f(int x)
{
	return x & -x;
}

void change(int t, int i, int x)
{
	for (; i < maxN; i += f(i))
	{
		fw[t][i] += x;
	}
}

int get(int t, int i)
{
	int res = 0;
	for (; i > 0; i -= f(i))
	{
		res += fw[t][i];
	}
	return res;
}


int main() {
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
#endif
	//srand(time(NULL));
	
	int n, m, k;
	scanf("%d%d%d", &n, &m, &k);

	row[0] = 0;
	pos[0] = 1;
	change(0, 1, 1);

	vector <pair<pair<int, int>, pair<int, int> > > e;

	for (int i = 1; i <= k; i++)
	{
		int a, b;
		scanf("%d%d", &a, &b);

		e.push_back(make_pair(make_pair(a, 1), make_pair(i, b - a)));
		e.push_back(make_pair(make_pair(b, -1), make_pair(i, b - a)));
	}

	sort(e.begin(), e.end());

	for (int i = 0; i < e.size(); i++)
	{
		int t = e[i].first.second, id = e[i].second.first, tm = e[i].second.second;
		if (t == 1)
		{
			int curr = 0;
			int taken = 0;
			for (int p = 20; p >= 0; p--)
			{
				if (curr + (1 << p) < maxN - 1 && curr + (1 << p) == fw[0][curr + (1 << p)] + taken)
				{
					curr += (1 << p);
					taken += fw[0][curr];
				}
			}
			if (get(0, curr) != curr || curr + 1 > m)
			{
				curr = 0;
				taken = 0;
				for (int p = 20; p >= 0; p--)
				{
					if (curr + (1 << p) < maxN - 1 && curr + (1 << p) == fw[1][curr + (1 << p)] + taken)
					{
						curr += (1 << p);
						taken += fw[1][curr];
					}
				}
				if (get(1, curr) == curr && curr + 1 <= m)
				{
					row[id] = 1;
					pos[id] = curr + 1;
					sum[curr + 1] += tm;
					change(1, curr + 1, 1);
				}
				else
				{
					row[id] = -1;
				}
			}
			else
			{
				row[id] = 0;
				pos[id] = curr + 1;
				change(0, curr + 1, 1);
			}
		}
		else
		{
			if (row[id] != -1)
			{
				change(row[id], pos[id], -1);
			}
		}
	}

	int mn = 1;
	for (int i = 1; i <= m; i++)
	{
		if (sum[i] < sum[mn])
		{
			mn = i;
		}
	}

	cout << sum[mn] << " " << mn;

	return 0;
}