#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <utility>
#include <fstream>
#include <sstream>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = 1e8;
const int MAXSIZE = 500010;

inline int id(char c) {
	return (c - 'a');
}

void mysort(vector < pair<int, char> > &v)
{
	for (int k = 0; k < 2; k++)
	{
		for (int i = (int)v.size() - 2; i >= k; i--)
		{
			if (abs(v[i].first) > abs(v[i + 1].first))
				swap(v[i], v[i + 1]);
		}
	}
}

int main() {
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
#endif
	//srand(time(NULL));

	char buf[MAXSIZE];
	int n, m;
	scanf("%d%d", &n, &m);

	vector<vector<char> > s(n, vector<char>(m));
	for (int i = 0; i < n; i++) {
		scanf("%s", &buf);
		for (int j = 0; j < m; j++) {
			s[i][j] = buf[j];
		}
	}

	//precalc
	vector<vector<vector<int> > > hmin(n, vector<vector<int> >(m, vector<int>(4, INF))), 
		vmin(n, vector<vector<int> >(m, vector<int>(4, INF)));

	for (int i = 0; i < n; i++) {
		int fmx = 0, smx = -1;
		hmin[i][0][0] = -1;
		hmin[i][0][1] = -1;
		for (int j = 1; j < m; j++) {
			hmin[i][j][0] = fmx;
			hmin[i][j][1] = smx;
			if (s[i][j] == s[i][fmx])
			{
				fmx = j;
			}
			else
			{
				smx = fmx;
				fmx = j;
			}
		}
		fmx = m - 1, smx = -1;
		hmin[i][m - 1][2] = -1;
		hmin[i][m - 1][3] = -1;
		for (int j = m - 2; j >= 0; j--)
		{
			hmin[i][j][2] = fmx;
			hmin[i][j][3] = smx;
			if (s[i][j] == s[i][fmx])
			{
				fmx = j;
			}
			else
			{
				smx = fmx;
				fmx = j;
			}
		}
	}

	for (int j = 0; j < m; j++)
	{
		int fmx = 0, smx = -1;
		vmin[0][j][0] = vmin[0][j][1] = -1;
		for (int i = 1; i < n; i++)
		{
			vmin[i][j][0] = fmx;
			vmin[i][j][1] = smx;
			if (s[i][j] == s[fmx][j])
			{
				fmx = i;
			}
			else
			{
				smx = fmx;
				fmx = i;
			}
		}
		fmx = n - 1, smx = -1;
		vmin[n - 1][j][2] = vmin[n - 1][j][3] = -1;
		for (int i = n - 2; i >= 0; i--)
		{
			vmin[i][j][2] = fmx;
			vmin[i][j][3] = smx;
			if (s[i][j] == s[fmx][j])
			{
				fmx = i;
			}
			else
			{
				smx = fmx;
				fmx = i;
			}
		}

	}

	//===

	int q;
	scanf("%d", &q);
	for (int i = 0; i < q; i++) {
		int x, y;
		scanf("%d%d", &x, &y);
		x--, y--;

		int mind = INF, minr, minc;
		for (int j = 0; j < 4; j++) {
			for (int k = 0; k < 4; k++) {
				int hc = hmin[x][y][j], vc = vmin[x][y][k];
				if (hc != -1 && vc != -1 && s[x][hc] != s[vc][y]) {
					int dist = abs(x - vc) + abs(y - hc);
					if (dist < mind) {
						mind = dist;
						minr = hc;
						minc = vc;
					}
				}
			}
		}

		if (mind > n + m) {
			printf("-1\n");
		}
		else {
			printf("%d %d %d %d\n", x + 1, minr + 1, minc + 1, y + 1);
		}
	}

	return 0;
}