#include <set>
#include <vector>
#include <iostream>
#include <algorithm>

#define INF 1791791791

using namespace std;

class RQ
{
    struct node
    {
        int result;
        int L = -1, R = -1;
        node *left = nullptr, *right = nullptr;
        node(){}
        node(const vector<int> & arr, int L, int R)
        {
            this->L = L;
            this->R = R;
            if (L + 1 == R) {
                result = arr[L];
            }
            else {
                int M = (L + R) / 2;
                left = new node(arr, L, M);
                right = new node(arr, M, R);
                result = min(left->result, right->result);
            }
        }
        void update(int point, int var)
        {
            if (L == point && R == L + 1)
                result = var;
            else if (point >= L && point <= R) {
                left->update(point, var);
                right->update(point, var);
                result = min(left->result, right->result);
            }
        }
        int query(int L, int R)
        {
            if (this->L >= L && this->R <= R)
                return result;
            else if (max(L, this->L) >= min(R, this->R))
                return INF;
            else
                return min(left->query(L, R), right->query(L, R));
        }
    };
    node start;
public:
    RQ(const vector<int> & arr)
    {
        start = node(arr, 0, arr.size());
    }
    void update(int point, int var) {
        start.update(point, var);
    }
    int query(int L, int R)
    {
        return start.query(L, R);
    }
};


int main()
{
    int n, k, m;
    cin >> n >> k >> m;
    vector<int> a(m);
    for (int i = 0; i < m; ++i)
        cin >> a[i];
    sort(a.begin(), a.end());
    set<pair<int, int>> s;
    for (int i = 0; i < m; ++i)
        s.insert({-a[i], i});
    vector<int> dp(m);
    for (int i = 0; i < m; ++i) {
        auto x = s.lower_bound({ -a[i] + k, -1 });
        if (x != s.end())
            dp[i] = dp[x->second] + a[i] - a[x->second] - k;
        else
            dp[i] = max(0, a[i] - k);
    }
    int ans = dp.back() + n - a.back();
    int j = m - 1;
    while (j >= 0 && n - a[j] <= k) {
        auto x = s.lower_bound({ -a[j]+1, -1 });
        if (x == s.end())
        {
            ans = max(ans, a.front() - 1);
        }
        else
            ans = max(ans, dp[x->second] + a[j] - a[x->second] - 1);
        --j;
    }
    cout << ans;
}