#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <queue>
#include <set>
#include <algorithm>
#include <map>
#include <bitset>
#include <string>
#include <string>

using namespace std;

typedef long long ll;

int solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
}

const int MAX_MEM = (int)5e8;
char MEM[MAX_MEM];
int cur = 0;

inline void* operator new(size_t n){
	char* res = MEM + cur;
	cur += n;
	return (void*)res;
}

inline void operator delete(void*) {}

inline int readChar();
template <class T = int> inline T readInt();
template <class T> inline void writeInt(T x, char end = 0);
inline void writeChar(int x);

static const int buf_size = 4096;

inline int getChar() {
	static char buf[buf_size];
	static int len = 0, pos = 0;
	if (pos == len)
		pos = 0, len = fread(buf, 1, buf_size, stdin);
	if (pos == len)
		return -1;
	return buf[pos++];
}

inline int readChar() {
	int c = getChar();
	while (c <= 32)
		c = getChar();
	return c;
}

template <class T>
inline T readInt() {
	int s = 1, c = readChar();
	T x = 0;
	if (c == '-')
		s = -1, c = getChar();
	while ('0' <= c && c <= '9')
		x = x * 10 + c - '0', c = getChar();
	return s == 1 ? x : -x;
}

static int write_pos = 0;
static char write_buf[buf_size];

inline void writeChar(int x) {
	if (write_pos == buf_size)
		fwrite(write_buf, 1, buf_size, stdout), write_pos = 0;
	write_buf[write_pos++] = x;
}

template <class T>
inline void writeInt(T x, char end) {
	if (x < 0)
		writeChar('-'), x = -x;

	char s[24];
	int n = 0;
	while (x || !n)
		s[n++] = '0' + x % 10, x /= 10;
	while (n--)
		writeChar(s[n]);
	if (end)
		writeChar(end);
}

struct Flusher {
	~Flusher() {
		if (write_pos)
			fwrite(write_buf, 1, write_pos, stdout), write_pos = 0;
	}
} flusher;

struct cond {
	int first, second;
	int x;
};

vector<string> A;
vector<vector<int> > PL[26], PR[26], PU[26], PD[26];
vector<vector<cond> > GR[3], GC[3];

vector<cond> Q;

int solve() {

	int n, m;
	n = readInt(), m = readInt();

	A.resize(n);

	for (int i = 0; i < 3; ++i) {
		GC[i].resize(n);
		GR[i].resize(n);
	}

	for (int i = 0; i < 26; i++) {
		PL[i].resize(n);
		PR[i].resize(n);
		PU[i].resize(n);
		PD[i].resize(n);
		for (int j = 0; j < n; j++) {
			PL[i][j].resize(m);
			PR[i][j].resize(m);
			PD[i][j].resize(m);
			PU[i][j].resize(m);
		}
	}

	for (int i1 = 0; i1 < 3; ++i1) {
		for (int i = 0; i < n; i++) {
			GR[i1][i].resize(m);
			GC[i1][i].resize(m);
		}
	}

	for (int i = 0; i < n; i++) {
		A[i].resize(m);
		for (int j = 0; j < m; ++j)
			A[i][j] = readChar();
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			for (int t = 0; t < 26; t++) {
				if (j > 0) {
					if (A[i][j - 1] - 'a' == t)
						PL[t][i][j] = 1;// { 1, t, i, j - 1 };
					else {
						PL[t][i][j] = PL[t][i][j - 1] + 1;
					}
				} else {
					PL[t][i][j] = (int)1e9;// { (int)1e9, t, 0, 0 };
				}

				if (i > 0) {
					if (A[i - 1][j] - 'a' == t)
						PU[t][i][j] = 1;// { 1, t, i - 1, j };
					else
						PU[t][i][j] = PU[t][i - 1][j] + 1;
				} else {
					PU[t][i][j] = (int)1e9;// { (int)1e9, t, 0, 0 };
				}
			}
		}
	}

	for (int i = n - 1; i >= 0; i--) {
		for (int j = m - 1; j >= 0; j--) {
			for (int t = 0; t < 26; t++) {
				if (j + 1 < m) {
					if (A[i][j + 1] - 'a' == t) {
						PR[t][i][j] = 1;// { 1, t, i, j + 1 };
					} else {
						PR[t][i][j] = PR[t][i][j + 1] + 1;
					}
				} else {
					PR[t][i][j] = (int)1e9;// { (int)1e9, t, 0, 0 };
				}

				if (i + 1 < n) {
					if (A[i + 1][j] - 'a' == t) {
						PD[t][i][j] = 1;// { 1, t, i + 1, j };
					} else {
						PD[t][i][j] = PD[t][i + 1][j] + 1;
					}
				} else {
					PD[t][i][j] = (int)1e9;// { (int)1e9, t, 0, 0 };
				}
			}
		}
	}
	
	Q.reserve(26);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			Q = vector<cond>(0);

			for (int t = 0; t < 26; t++) {
				if (PL[t][i][j] < PR[t][i][j])
					Q.push_back({ PL[t][i][j], t, j - PL[t][i][j] });
				else
					Q.push_back({ PR[t][i][j], t, j + PR[t][i][j] });
			}

			for (int kk = 0; kk < 3; ++kk)
				GR[kk][i][j] = { (int)1e9, 0, 0 };

			for (int k = 0; k < (int)Q.size(); k++) {
				int cur = Q[k].first;
				if (cur <= GR[0][i][j].first) {
					GR[2][i][j] = GR[1][i][j];
					GR[1][i][j] = GR[0][i][j];
					GR[0][i][j] = Q[k];
				} else if (cur <= GR[1][i][j].first) {
					GR[2][i][j] = GR[1][i][j];
					GR[1][i][j] = Q[k];
				} else if (cur <= GR[2][i][j].first) {
					GR[2][i][j] = Q[k];
				}
			}
		}
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			Q = vector<cond>(0);

			for (int t = 0; t < 26; t++) {
				if (PU[t][i][j] < PD[t][i][j])
					Q.push_back({ PU[t][i][j], t, i - PU[t][i][j] });
				else
					Q.push_back({ PD[t][i][j], t, i + PD[t][i][j] });
			}

			for (int kk = 0; kk < 3; ++kk)
				GC[kk][i][j] = { (int)1e9, 0, 0 };

			for (int k = 0; k < (int)Q.size(); k++) {
				int cur = Q[k].first;
				if (cur <= GC[0][i][j].first) {
					GC[2][i][j] = GC[1][i][j];
					GC[1][i][j] = GC[0][i][j];
					GC[0][i][j] = Q[k];
				} else if (cur <= GC[1][i][j].first) {
					GC[2][i][j] = GC[1][i][j];
					GC[1][i][j] = Q[k];
				} else if (cur <= GC[2][i][j].first) {
					GC[2][i][j] = Q[k];
				}
			}
		}
	}

	int q;
	q = readInt();
	while (q--) {
		int i, j;
		i = readInt(), j = readInt();
		i--, j--;

		int c = A[i][j] - 'a';
		int ans = (int)1e9;
		int X, Y;

		for (int i1 = 0; i1 < 3; ++i1) {
			cond c1 = GC[i1][i][j];
			for (int i2 = 0; i2 < 3; ++i2) {
				cond c2 = GR[i2][i][j];
				if (c1.second != c2.second) {
					if (ans > c1.first + c2.first) {
						ans = c1.first + c2.first;
						X = c1.x;
						Y = c2.x;
					}
					break;
				}
			}
		}
		if (ans == (int)1e9)
			writeInt(-1, '\n');
		else
			writeInt(X + 1, ' '), writeInt(j + 1, ' '), writeInt(i + 1, ' '), writeInt(Y + 1, '\n');
	}

	return 0;
}