#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
using namespace std;


long long n, k, m;


long long dst(pair <long long, long long> A, pair <long long, long long> B) {
//    if (A.second < B.first)
    return max(0LL, min(A.second, B.second) - max(A.first, B.first) + 1LL);
}

int sol_1(vector <long long> & day) {
    vector <pair <long long, long long> > ans;
    ans.push_back(make_pair(day[0LL] - k + 1, day[0LL]));
    for (long long i = 1; i < day.size(); i++) {
        if (day[i] > ans.back().second) {
            ans.push_back(make_pair(day[i], day[i] + k - 1));
        }
    }
    long long answer = 0LL;
    for (auto elem : ans) {
        answer += dst(elem, make_pair(1LL, n));
    }
    return n - answer;
}

int sol_2(vector <long long> & day) {
    vector <pair <long long, long long> > ans;
    ans.push_back(make_pair(day[0LL], day[0LL] + k - 1));
    for (long long i = 1; i < day.size(); i++) {
        if (day[i] > ans.back().second) {
            ans.push_back(make_pair(day[i], day[i] + k - 1));
        }
    }
    long long answer = 0LL;
    for (auto elem : ans) {
        answer += dst(elem, make_pair(1, n));
    }
    return n - answer;
}

int sol(vector <long long> & day) {
    vector <long long> dp(m + 1);
    dp[0] = 0LL;
    dp[1] = max(n - (day.back() + k), 0LL);
    for (long long i = 1; i <= m; ++i)
    {
        long long ind = upper_bound(day.begin(), day.end(), day[m - i] + k - 1) - day.begin();

        if (ind == m)
        {
            dp[i] = max((n - (day[m - i] + k - 1)), 0LL);
        }
        else
        {
            dp[i] = dp[m - ind] + day[ind] - day[m - i] - k;
        }
    }
    long long pt = 0LL;
    long long ans = dp[m] + day[0] - 1;
    while (pt < m && day[pt] <= k)
    {
        if (pt == m - 1) {
            ans = max(ans, n - day.back());
        }
        ans = max(ans, day[pt + 1] - day[pt] - 1 + dp[m - pt - 1]);
        pt++;
    }
    return ans;
}

int main() {

    cin >> n >> k >> m;
    vector <long long> day(m);
    for (long long i = 0LL; i < m; i++) {
        cin >> day[i];
    }
    sort(day.begin(), day.end());
    int answ = sol(day);
    answ = max(answ, sol_1(day));
    answ = max(answ, sol_2(day));
    reverse(day.begin(), day.end());
    for (int i = 0; i < m; i++) {
        day[i] = n + 1 - day[i];
    }
    answ = max(answ, sol(day));
    answ = max(answ, sol_1(day));
    answ = max(answ, sol_2(day));
    cout << answ << endl;
}
