#include <iostream>
#include <stdio.h>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <climits>
#include <cinttypes>

using namespace std;

typedef long long i64;
typedef pair < int, int > pii;
typedef pair < int, pii > piii;
#define mp(x, y) make_pair(x, y)
#define tri(x, a, b, c) x(a, x(b, c))
#define quad(x, a, b, c, d) x(x(a, b), x(c, d))
#define mendl '\n'
const int INF = 1e9 + 7;
#define X first
#define Y second

int main() {

#ifdef _DEBUG
	freopen("Text.txt", "r", stdin);
#endif

	ios::sync_with_stdio(0);
	cin.tie(0);

	int h, w, n;
	cin >> h >> w >> n;

	int k;
	string s;
	cin >> s;
	k = s.size();

	vector < vector < int > > ops(4);
	int m, mod;
	for (int i = 0; i < 4; i++) {
		if (i % 2)
			mod = w;
		else
			mod = h;

		cin >> m;
		ops[i].resize(k);
		for (int j = 0; j < k; j++) {
			if (j < m) {
				cin >> ops[i][j];
			}
			else {
				ops[i][j] = (10007 * ops[i][j - 2] + 10009 * ops[i][j - 1] + 87277) % mod;
			}
		}
	}

	vector < vector < int > > board(h, vector < int >(w));
	for (int i = 0; i < h; i++) {
		for (int j = 0; j < w; j++) {
			board[i][j] = i * w + j;
		}
	}

	vector < int > cur_h(h), cur_w(w);
	for (int i = 0; i < h; i++) {
		cur_h[i] = i;
	}

	for (int i = 0; i < w; i++) {
		cur_w[i] = i;
	}
	
	int a, b, c, d;
	for (int i = 0; i < k; i++) {

		a = ops[0][i];
		b = ops[1][i];
		c = ops[2][i];
		d = ops[3][i];

		if (s[i] == 'c') {
			swap(cur_w[d], cur_w[b]);
		}

		if (s[i] == 'r') {
			swap(cur_h[a], cur_h[c]);
		}

		if (s[i] == 'f') {
			swap(board[cur_h[a]][cur_w[b]], board[cur_h[c]][cur_h[d]]);
		}

	}

	i64 ans = 0;

	vector < int > seventeen(h);
	seventeen[0] = 1;
	for (int i = 1; i < h; i++) {
		seventeen[i] = (seventeen[i - 1] * 17) % INF;
	}
	vector < int > nineteen(w);
	nineteen[0] = 1;
	for (int i = 1; i < w; i++) {
		nineteen[i] = (nineteen[i - 1] * 19) % INF;
	}

	i64 add;
	for (int i = 0; i < h; i++) {
		for (int j = 0; j < w; j++) {
			add = (board[cur_h[i]][cur_w[j]] * seventeen[i]) % INF;
			add = (add * nineteen[j]) % INF;
			ans = ans + add;
		}
	}

	cout << ans;

	return 0;
}
