import java.io.*;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;
import java.util.TreeSet;

/**
 * Created by orspc on 11.12.2016.
 */
public class TaskC {

    int m;
    int[] d;

    public void solve() throws IOException {
        int n = nextInt(), k = nextInt();
        m = nextInt();
        d = new int[m];
        for (int i = 0; i < m; i++) {
            d[i] = nextInt();
        }
        Arrays.sort(d);
        int[] prev = new int[m + 1];
        for (int i = 0; i < m; i++) {
            prev[i] = search(d[i] - k);
        }
        prev[m] = search(n - k + 1);
        int[] dp = new int[m];
        TreeSet<Pair> set = new TreeSet<>();
        set.add(new Pair(-1, 0));
        for (int i = 0; i < m; i++) {
            while (!set.isEmpty() && set.first().i < prev[i]) {
                set.pollFirst();
            }
            if (!set.isEmpty()) {
                Pair r = set.first();
                dp[i] = r.val + Math.min(k, d[i]);
            } else {
                dp[i] = i == 0 ? k : dp[i - 1] + k;
            }
            set.add(new Pair(i, dp[i]));
        }
        while (!set.isEmpty() && set.first().i < prev[m]) {
            set.pollFirst();
        }

        int res = dp[m - 1];
        for (Pair p : set) {
            if (p.i != -1) {
                res = Math.min(res, n - d[p.i] + 1 + (p.i > 0 ? dp[p.i - 1] : 0));
            }
        }
        out.print(n - res);
    }

    class Pair implements Comparable<Pair> {
        int i, val;

        public Pair(int i, int val) {
            this.i = i;
            this.val = val;
        }

        @Override
        public int compareTo(Pair o) {
            return val == o.val ? Integer.compare(o.i, i) : Integer.compare(val, o.val);
        }
    }

    int search(int day) {
        int l = -1, r = m;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (d[mid] > day) {
                r = mid;
            } else {
                l = mid;
            }
        }

        return l;
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new TaskC().run();
    }
}
