#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define all(s) (s).begin(), (s).end()

vector<int> p;

void update(int v, int tl, int tr, int x, int pos) {
	if (tl == tr) {
		p[v] = x;
	}
	else {
		int m = (tl + tr) / 2;
		if (pos <= m) {
			update(v * 2, tl, m, x, pos);
		}
		else {
			update(v * 2 + 1, m + 1, tr, x, pos);
        }

		p[v] = max(p[v * 2], p[v * 2 + 1]);
    }
}

int get(int v, int tl, int tr, int L, int R) {
	if (tl > R || tr < L) {
		return 0;
	}
	else if (L <= tl && tr <= R) {
		return p[v];
	}
	else {
		int m = (tl + tr) / 2;
		return max(get(v * 2, tl, m, L, R), get(v * 2 + 1, m + 1, tr, L, R));
    }
}

int main() {
	int n, k, m;

	cin >> n >> k >> m;

	vector<int> s(m);
	vector<vector<int> > dp(m, vector<int>(2, 0));
	p.resize(m * 5, 0);

	for (int i = 0; i < m; i++) {
		cin >> s[i];
    }

	sort(all(s));

	dp[0][0] = max(s[0] - k, 0);

	{
		int it = upper_bound(all(s), s[0] + k - 1) - s.begin();
		dp[0][1] = s[0] - 1;
		update(1, 1, m, dp[0][1] + s[it] - (s[0] + k - 1) - 1, 1);
	}
    
	for (int i = 1; i < m; i++) {
		int it = lower_bound(all(s), s[i] - k + 1) - s.begin(), b = s[i] - k + 1;
		if (it == 0) {
			dp[i][0] = b;
		} else {
			int l = 0, r = it, id1, id2;
			while (r - l > 1) {
				int mid = (l + r) / 2;
				if (s[mid] + k - 1 < b) {
					l = mid;
				}
				else {
					r = mid;
                }
            }

			id1 = l;

			l = 0, r = id1 + 1;
			while (r - l > 1) {
				int mid = (l + r) / 2;
				if (s[mid] + k - 1 >= s[it - 1]) {
					r = mid;
				}
				else {
					l = mid;
				}
			}

			id2 = r;

			dp[i][0] = max(get(1, 1, m, id2 + 1, id1 + 1), dp[it - 1][0] + b - s[it - 1] - 1);
        }

		it = i;
		b = s[i];

		int l = 0, r = it, id1, id2;
		while (r - l > 1) {
			int mid = (l + r) / 2;
			if (s[mid] + k - 1 < b) {
				l = mid;
			}
			else {
				r = mid;
			}
		}

		id1 = l;

		l = 0, r = id1 + 1;
		while (r - l > 1) {
			int mid = (l + r) / 2;
			if (s[mid] + k - 1 >= s[it - 1]) {
				r = mid;
			}
			else {
				l = mid;
			}
		}

		if (r == id1 + 1) {
			r = id1;
        }

		id2 = r;

		dp[i][1] = max(get(1, 1, m, id2 + 1, id1 + 1), dp[it - 1][0] + b - s[it - 1] - 1);

		l = i, r = m;

		while (r - l > 1) {
			int mid = (l + r) / 2;
			if (s[mid] <= s[i] + k - 1) {
				l = mid;
			}
			else {
				r = mid;
            }
        }

		int tmp = 0;

		if (l >= m - 1) {
			tmp = n - (s[i] + k) + 1;
		}
		else {
			tmp = s[l + 1] - (s[i] + k) + 1;
        }

		update(1, 1, m, dp[i][1] + tmp, i + 1);
    }

	int ans = 0;

	for (int i = 0; i < m; i++) {
		if (s[i] + k - 1 >= s[m - 1]) {
			ans = max(ans, dp[i][1] + max(n - (s[i] + k), 0));
        }
    }

	cout << ans << '\n';

	return 0;
}
