#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <initializer_list>
#include <tuple>

using namespace std;

vector <vector <int> > hpa, hpb, vpa, vpb;
#define stomp(x) fprintf(stderr, "stomp " x "\n"); fflush(stderr)

int INF = 1e9;

const int N = 2 * 1e5 + 10;

enum {
	CLOSE, OPEN
};

struct T {
	int x;
	int i;
	int o;

	T() {}
	T (int x, int i, int o) : x(x), i(i), o(o) {}

	bool operator < (const T &arg) const {
		if (x == arg.x) {
			if (o == arg.o) {
				return i < arg.i;
			}
			return o < arg.o;
		}
		return x < arg.x;
	}
};

int tree[4 * N];
int o = 1;

int getsum(int l, int r) {
	l += o - 1; r += o - 1;
	int res = 0;
	while (l <= r) {
		if (l % 2 == 1) {
			res += tree[l];
			l++;
		}
		if (r % 2 == 0) {
			res += tree[r];
			r--;
		}
		l /= 2;
		r /= 2;
	}
	return res;
}

void add(int pos, int const& x) {
	pos += o - 1;
	tree[pos] += x;
	pos /= 2;
	while (pos) {
		tree[pos] = tree[2 * pos] + tree[2 * pos + 1];
		pos /= 2;
	}
	return;
}

vector < T > pass;

int bg[N];
int place[N];
int time[N];
bool sidit[N];

int s = 0;

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int n, m, k;
	scanf("%d %d %d", &n, &m, &k);

	while (o < m) o *= 2;

	pass.resize(2 * k);
	for (int i = 0; i < k; i++) {
		int a, b;
		scanf("%d %d", &a, &b);
		pass[2 * i] = T(a, i, OPEN);
		pass[2 * i + 1] = T(b, i, CLOSE);
	}

	sort(pass.begin(), pass.end());
	s = 1;

	for (int i = 0; i < pass.size(); i++) {
		if (pass[i].o == CLOSE) {
			if (sidit[pass[i].i]) {
				s--;
			} else {
				time[place[pass[i].i]] += pass[i].x - bg[pass[i].i];
				//printf("id %d place %d time %d\n", pass[i].i, place[pass[i].i], time[place[pass[i].i]]);
				add(place[pass[i].i], -1);
			}
		} else {
			if (getsum(1, m) == m) {
				continue;
			}
			if (s == m) {
				bg[pass[i].i] = pass[i].x;
				int l = 0, r = k + 1;
				while (l + 1 < r) {
					int m = (l + r) / 2;
					if (m == (m == 0 ? 0 : getsum(1, m))) {
						l = m;
					} else {
						r = m;
					}
				}
				//printf("%d = %d\n", pass[i].i, r);
				place[pass[i].i] = r;
				add(r, 1);
			} else {
				s++;
				sidit[pass[i].i] = true;
			}
		}
	}

	int mti = 1;
	for (int i = 2; i <= m; i++) {
		if (time[i] < time[mti]) {
			mti = i;
		}
	}

	printf("%d %d", time[mti], mti);

/*
	int h, w;
	scanf("%d %d\n", &h, &w);
	hpa.resize(h + 1);
	hpb.resize(h + 1);
	vpa.resize(h + 1);
	vpb.resize(h + 1);

	for (int i = 0; i < w; i++) {
		hpa[i] = vector <int> (w + 1);
		hpb[i] = vector <int> (w + 1);
		vpa[i] = vector <int> (w + 1);
		vpb[i] = vector <int> (w + 1);
	}

	for (int i = 1; i <= h; i++) {
		for (int j = 1; j <= w; j++) {
			char c;
			scanf("%c", &c);
			if (c == 'a') {
				hpa[i][j] = hpa[i][j - 1] + 1;
				hpb[i][j] = hpb[i][j - 1];
				vpa[i][j] = vpa[i - 1][j] + 1;
				vpb[i][j] = vpb[i - 1][j];
			} else if (c == 'b') {
				hpa[i][j] = hpa[i][j - 1];
				hpb[i][j] = hpb[i][j - 1] + 1;
				vpa[i][j] = vpa[i - 1][j];
				vpb[i][j] = vpb[i - 1][j] + 1;
			}
		}
		scanf("\n");
	}

	printf("hpa:\n");
	for (int i = 0; i <= h; i++) {
		for (int j = 0; j <= w; j++) {
			printf("%d ", hpa[i][j]);
		}
		printf("\n");
	}
	printf("\n");
	fflush(stdout);
	printf("vpa:\n");
	for (int i = 0; i <= h; i++) {
		for (int j = 0; j <= w; j++) {
			printf("%d ", vpa[i][j]);
		}
		printf("\n");
	}
	printf("\n");
	fflush(stdout);

	int q;
	scanf("%d", &q);

	for (int k = 0; k < q; k++) {
		int i, j;
		scanf("%d %d", &i, &j);
		if (vpa[h][j] - (vpa[i][j] - vpa[i - 1][j]) == 0 && hpa[i][w] - (hpa[i][j] - hpa[i][j - 1]) == 0) {
			printf("-1\n");
			continue;
		}
		if (vpb[h][j] - (vpb[i][j] - vpb[i - 1][j]) == 0 && hpb[i][w] - (hpb[i][j] - hpb[i][j - 1]) == 0) {
			printf("-1\n");
			continue;
		}
		stomp("begin");
		// hor a | ver b
		// hor left a
		int l = 1, r = j;
		int cmp = hpa[i][j];
		if (hpa[i][j] - hpa[i][j - 1] == 1) cmp--;
		while (l + 1 < r) {
			int m = (l + r) / 2;
			if (hpa[i][m] < cmp) {
				l = m;
			} else {
				r = m;
			}
		}
		int la;
		if (hpa[i][r] == cmp) {
			la = r;
		} else {
			la = -INF;
		}
		stomp("hor left a");

		// hor right a
		l = j + 1, r = w + 1;
		while (l + 1 < r) {
			int m = (l + r) / 2;
			if (hpa[i][m] <= cmp) {
				l = m;
			} else {
				r = m;
			}
		}
		int ra = (hpa[i][r] - hpa[i][r - 1] == i ? r : INF);
		stomp("hor right a");

		// ver up b
		l = 1, r = i;
		cmp = vpb[i][j];
		if (vpb[i][j] - vpb[i - 1][j] == 1) cmp--;
		while (l + 1 < r) {
			int m = (l + r) / 2;
			if (vpb[m][j] < cmp) {
				l = m;
			} else {
				r = m;
			}
		}
		int ub = (vpb[r][j] == cmp ? r : -INF);
		stomp("ver up b");

		// ver down b
		l = i + 1, r = h + 1;
		while (l + 1 < r) {
			int m = (l + r) / 2;
			if (vpb[m][j] <= cmp) {
				l = m;
			} else {
				r = m;
			}
		}
		int db = (vpb[r][j] - vpb[r - 1][j] == 1 ? r : INF);
		stomp("ver down b");

		// hor b | ver a
		// hor left b
		l = 1, r = j;
		cmp = hpb[i][j];
		if (hpb[i][j] - hpb[i][j - 1] == 1) cmp--;
		while (l + 1 < r) {
			int m = (l + r) / 2;
			if (hpb[i][m] < cmp) {
				l = m;
			} else {
				r = m;
			}
		}
		int lb = (hpb[i][r] == cmp ? r : -INF);
		stomp("hor left b");

		// hor right b
		l = j + 1, r = w + 1;
		while (l + 1 < r) {
			int m = (l + r) / 2;
			if (hpb[i][m] <= cmp) {
				l = m;
			} else {
				r = m;
			}
		}
		int rb = (hpb[i][r] - hpb[i][r - 1] == 1 ? r : INF);
		stomp("hor right b");

		// ver up a
		l = 1, r = i;
		cmp = vpa[i][j];
		if (vpa[i][j] - vpa[i - 1][j] == 1) cmp--;
		while (l + 1 < r) {
			int m = (l + r) / 2;
			if (vpa[m][j] < cmp) {
				l = m;
			} else {
				r = m;
			}
		}
		int ua = (vpa[r][j] == cmp ? r : -INF);
		stomp("ver up a");

		// ver down a
		l = i + 1, r = h + 1;
		while (l + 1 < r) {
			int m = (l + r) / 2;
			if (vpa[m][j] <= cmp) {
				l = m;
			} else {
				r = m;
			}
		}
		int da = (vpa[r][j] - vpa[r - 1][j] == 1 ? r : INF);
		stomp("ver down a");

		int ha, va, hb, vb;
		if (j - la < ra - j) {
			ha = la;
		} else {
			ha = ra;
		}
		if (i - ua < da - i) {
			va = ua;
		} else {
			va = da;
		}
		if (j - lb < rb - j) {
			hb = lb;
		} else {
			hb = rb;
		}
		if (i - ub < db - i) {
			vb = ub;
		} else {
			vb = db;
		}

		if (ha + vb < hb + va) {
			printf("%d %d %d %d\n", i, ha, vb, j);
		} else {
			printf("%d %d %d %d\n", i, hb, va, j);
		}
	}
*/
}

