#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <initializer_list>
#include <tuple>

using namespace std;

vector <vector <int> > hpa, hpb, vpa, vpb;
#define stomp(x) fprintf(stderr, "stomp " x "\n"); fflush(stderr)

int INF = 1e9;

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int h, w;
	scanf("%d %d\n", &h, &w);
	hpa.resize(h + 1);
	hpb.resize(h + 1);
	vpa.resize(h + 1);
	vpb.resize(h + 1);

	for (int i = 0; i <= h; i++) {
		hpa[i] = vector <int> (w + 1);
		hpb[i] = vector <int> (w + 1);
		vpa[i] = vector <int> (w + 1);
		vpb[i] = vector <int> (w + 1);
	}

	for (int i = 1; i <= h; i++) {
		for (int j = 1; j <= w; j++) {
			char c;
			scanf("%c", &c);
			if (c == 'a') {
				hpa[i][j] = hpa[i][j - 1] + 1;
				hpb[i][j] = hpb[i][j - 1];
				vpa[i][j] = vpa[i - 1][j] + 1;
				vpb[i][j] = vpb[i - 1][j];
			} else if (c == 'b') {
				hpa[i][j] = hpa[i][j - 1];
				hpb[i][j] = hpb[i][j - 1] + 1;
				vpa[i][j] = vpa[i - 1][j];
				vpb[i][j] = vpb[i - 1][j] + 1;
			}
		}
		scanf("\n");
	}

	/*printf("hpa:\n");
	for (int i = 0; i <= h; i++) {
		for (int j = 0; j <= w; j++) {
			printf("%d ", hpa[i][j]);
		}
		printf("\n");
	}
	printf("\n");
	fflush(stdout);
	printf("vpa:\n");
	for (int i = 0; i <= h; i++) {
		for (int j = 0; j <= w; j++) {
			printf("%d ", vpa[i][j]);
		}
		printf("\n");
	}
	printf("\n");
	fflush(stdout);
	*/

	int q;
	scanf("%d", &q);

	for (int k = 0; k < q; k++) {
		int i, j;
		scanf("%d %d", &i, &j);
		if (vpa[h][j] - (vpa[i][j] - vpa[i - 1][j]) == 0 && hpa[i][w] - (hpa[i][j] - hpa[i][j - 1]) == 0) {
			printf("-1\n");
			fflush(stdout);
			continue;
		}
		if (vpb[h][j] - (vpb[i][j] - vpb[i - 1][j]) == 0 && hpb[i][w] - (hpb[i][j] - hpb[i][j - 1]) == 0) {
			printf("-1\n");
			fflush(stdout);
			continue;
		}
		//stomp("begin");
		// hor a | ver b
		// hor left a
		int cmp = hpa[i][j];
		if (hpa[i][j] - hpa[i][j - 1] == 1) cmp--;
		int la = lower_bound(hpa[i].begin(), hpa[i].begin() + j, cmp) - hpa[i].begin();
		if (hpa[i][la] != cmp || la == 0) {
			la = -INF;
		}
		if (cmp == 0) {
			la = -INF;
		}
		//printf("la: %d\n", la);
		//stomp("hor left a");

		// hor right a
		cmp = hpa[i][j];
		int ra = lower_bound(hpa[i].begin() + j + 1, hpa[i].end(), cmp + 1) - hpa[i].begin();
		if (hpa[i][ra] != cmp + 1) {
			ra = INF;
		}
		//printf("ra: %d\n", ra);
		//stomp("hor right a");

		// ver up b
		int l = 0, r = i - 1;
		cmp = vpb[i][j];
		if (vpb[i][j] - vpb[i - 1][j] == 1) cmp--;
		while (l + 1 < r) {
			int m = (l + r) / 2;
			if (vpb[m][j] < cmp) {
				l = m;
			} else {
				r = m;
			}
		}
		int ub = ((vpb[r][j] == cmp && r != 0) ? r : -INF);
		if (cmp == 0) {
			ub = -INF;
		}
		//printf("ub: %d\n", ub);
		//stomp("ver up b");

		// ver down b
		l = i, r = h;
		cmp = vpb[i][j];
		while (l + 1 < r) {
			int m = (l + r) / 2;
			if (vpb[m][j] < cmp + 1) {
				l = m;
			} else {
				r = m;
			}
		}
		//printf("r: %d\n", r);
		int db = (vpb[r][j] == cmp + 1 ? r : INF);
		//printf("db: %d\n", db);
		//stomp("ver down b");

		// hor b | ver a
		// hor left b
		l = 0, r = j - 1;
		cmp = hpb[i][j];
		if (hpb[i][j] - hpb[i][j - 1] == 1) cmp--;
		while (l + 1 < r) {
			int m = (l + r) / 2;
			if (hpb[i][m] < cmp) {
				l = m;
			} else {
				r = m;
			}
		}
		int lb = ((hpb[i][r] == cmp && r != 0) ? r : -INF);
		if (cmp == 0) {
			lb = -INF;
		}
		//printf("lb: %d\n", lb);
		//stomp("hor left b");

		// hor right b
		l = j, r = w;
		cmp = hpb[i][j];
		while (l + 1 < r) {
			int m = (l + r) / 2;
			if (hpb[i][m] < cmp + 1) {
				l = m;
			} else {
				r = m;
			}
		}
		int rb = (hpb[i][r] == cmp + 1 ? r : INF);
		//printf("rb: %d\n", rb);
		//stomp("hor right b");

		// ver up a
		l = 0, r = i - 1;
		cmp = vpa[i][j];
		if (vpa[i][j] - vpa[i - 1][j] == 1) cmp--;
		while (l + 1 < r) {
			int m = (l + r) / 2;
			if (vpa[m][j] < cmp) {
				l = m;
			} else {
				r = m;
			}
		}
		int ua = ((vpa[r][j] == cmp && r != 0) ? r : -INF);
		if (cmp == 0) {
			ua = -INF;
		}
		//printf("ua: %d\n", ua);
		//stomp("ver up a");

		// ver down a
		l = i, r = h;
		cmp = vpa[i][j];
		while (l + 1 < r) {
			int m = (l + r) / 2;
			if (vpa[m][j] < cmp + 1) {
				l = m;
			} else {
				r = m;
			}
		}
		int da = (vpa[r][j] == cmp + 1 ? r : INF);
		//printf("da: %d\n", da);
		//stomp("ver down a");

		int mnai, mnaj, mnbi, mnbj;
		mnai = mnaj = -INF;
		mnbi = mnbj = INF;

		if (abs(mnai - mnbi) + abs(mnaj - mnbj) > abs(la - j) + abs(ub - i)) {
			mnaj = la;
			mnai = i;
			mnbj = j;
			mnbi = ub;
			//printf("la ub\n");
		}
		if (abs(mnai - mnbi) + abs(mnaj - mnbj) > abs(la - j) + abs(db - i)) {
			mnaj = la;
			mnai = i;
			mnbj = j;
			mnbi = db;
			//printf("ra db\n");
		}
		if (abs(mnai - mnbi) + abs(mnaj - mnbj) > abs(ra - j) + abs(ub - i)) {
			mnaj = ra;
			mnai = i;
			mnbj = j;
			mnbi = ub;
		}
		if (abs(mnai - mnbi) + abs(mnaj - mnbj) > abs(ra - j) + abs(db - i)) {
			mnaj = ra;
			mnai = i;
			mnbj = j;
			mnbi = db;
		}
		if (abs(mnai - mnbi) + abs(mnaj - mnbj) > abs(lb - j) + abs(ua - i)) {
			mnaj = j;
			mnai = ua;
			mnbj = lb;
			mnbi = i;
		}
		if (abs(mnai - mnbi) + abs(mnaj - mnbj) > abs(lb - j) + abs(da - i)) {
			mnaj = j;
			mnai = da;
			mnbj = lb;
			mnbi = i;
		}
		if (abs(mnai - mnbi) + abs(mnaj - mnbj) > abs(rb - j) + abs(ua - i)) {
			mnaj = j;
			mnai = ua;
			mnbj = rb;
			mnbi = i;
		}
		if (abs(mnai - mnbi) + abs(mnaj - mnbj) > abs(rb - j) + abs(da - i)) {
			mnaj = j;
			mnai = da;
			mnbj = rb;
			mnbi = i;
		}

		printf("%d %d %d %d\n", mnai, mnaj, mnbi, mnbj);

		int ha, va, hb, vb;
		if (j - la < ra - j) {
			ha = la;
		} else {
			ha = ra;
		}
		if (i - ua < da - i) {
			va = ua;
		} else {
			va = da;
		}
		if (j - lb < rb - j) {
			hb = lb;
		} else {
			hb = rb;
		}
		if (i - ub < db - i) {
			vb = ub;
		} else {
			vb = db;
		}

		//printf("%d %d %d %d\n", ha, va, hb, vb);

		if (abs(j - ha) + abs(i - vb) < abs(j - hb) + abs(i - va)) {
			//printf("%d %d %d %d\n", i, ha, vb, j);
		} else {
			//printf("%d %d %d %d\n", i, hb, va, j);
		}
		fflush(stdout);
	}
}

