#include <cstdio>
#include <iostream>
#include <array>
#include <algorithm>
#include <vector>
#include <queue>
#include <functional>

using namespace std;

struct passenger
{
  int n, st, sec, io;

  passenger(int n = 0, int st = 0, int sec = 0, int io = 0) : n(n), st(st), sec(sec), io(io)
  {
  }

  bool operator<(const passenger &p)
  {
    return st < p.st || (st == p.st && io > p.io) || (st == p.st && io == p.io && n < p.n);
  }
};

int res[200000];
bool stands[200000];
int place[200000];

int main(void)
{
  int n, m, k, free;
  scanf("%d%d%d", &n, &m, &k);
  vector<passenger> smth(2 * k);
  priority_queue<int, vector<int>, greater<int>> frstd;

  for (int i = 0; i < k; i++)
  {
    int a, b;
    scanf("%d%d", &a, &b);
    smth[2 * i] = passenger(i, a, b, 1);
    smth[2 * i + 1] = passenger(i, b, -1, 2);
  }
  for (int i = 0; i < m; i++)
    frstd.push(i);

  sort(smth.begin(), smth.end());
  int cur = 1;
  for (int i = 0; i < 2 * k; i++)
  {
    if (smth[i].io == 1)
    {
      if (cur == m)
      {
        if (frstd.size() != 0)
        {
          place[smth[i].n] = frstd.top();
          res[frstd.top()] += smth[i].sec - smth[i].st;
          stands[smth[i].n] = true;
          frstd.pop();
        }
      }
      else
        cur++;
    }
    else if (!stands[smth[i].n])
      cur--;
    else
      frstd.push(place[smth[i].n]);
  }

  int mn = 10000000, mnnum;
  for (int i = 0; i < m; i++)
    if (mn > res[i])
      mn = res[i], mnnum = i;
  cout << mn << " " << mnnum + 1 << endl;
  return 0;
}