#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

int n, m, k;
vector <int> days;
int dp[1000000], dp2[1000000];

inline int getDP(int* dp, int x) {
    int id = (int)(upper_bound(days.begin(), days.end(), x) - days.begin()) - 1;
    if (id < 0)
        return 0;
    else
        return dp[id];
}

inline int addSeg(int l, int r) {
    if (l > n) l = n;
    if (r > n) r = n;
    if (l < 1) l = 1;
    if (r < 1) r = 1;
    return r-l+1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin >> n >> m >> k;
    days.resize(k);
    for (int i = 0; i < k; i++)
        cin >> days[i];
    sort(days.begin(), days.end());

    for (int i = 0; i < k; i++)
        dp[i] = getDP(dp, days[i] - m) + addSeg(days[i] - m + 1, days[i]);

    for (int i = 0; i < k; i++)
        days[i] = n - days[i] + 1;
    reverse(days.begin(), days.end());

    for (int i = 0; i < k; i++)
        dp2[i] = getDP(dp2, days[i] - m) + addSeg(days[i] - m + 1, days[i]);

    int ans = min(dp[k-1], dp2[k-1]);
    for (int i = 0; i + 1 < k; i++)
        ans = min(ans, dp[i] + dp2[k - i - 2]);

    cout << n - ans << endl;
    return 0;
}



