#include <stdio.h>
#include <algorithm>

using std::abs;

const int maxN = 500000;

int n, m;
char* v[maxN+1];
int *rowL[26][maxN+1], *rowR[26][maxN+1];
int *colL[26][maxN+1], *colR[26][maxN+1];

int main() {
    scanf("%d%d", &n, &m);
    for (int i = 0; i < n; i++) {
        v[i] = new char[m + 1];
        scanf("%s", v[i]);
    }
    for (int k = 0; k < 26; k++) {
        for (int i = 0; i < n; i++) {
            rowL[k][i] = new int[m];
            rowR[k][i] = new int[m];
            rowL[k][i][0] = rowR[k][i][m-1] = -12345678;
        }
        for (int i = 0; i < m; i++) {
            colL[k][i] = new int[n];
            colR[k][i] = new int[n];
            colL[k][i][0] = colR[k][i][n-1] = -12345678;
        }
    }
    for (int k = 0; k < 26; k++) {
        for (int i = 0; i < n; i++)
            for (int j = 0; j + 1 < m; j++) {
                if (v[i][j] == k + 'a')
                    rowL[k][i][j+1] = j;
                else
                    rowL[k][i][j+1] = rowL[k][i][j];
            }

        for (int i = 0; i < n; i++)
            for (int j = m - 1; j > 0; j--) {
                if (v[i][j] == k + 'a')
                    rowR[k][i][j-1] = j;
                else
                    rowR[k][i][j-1] = rowR[k][i][j];
            }

        for (int i = 0; i + 1 < n; i++)
            for (int j = 0; j < m; j++) {
                if (v[i][j] != k + 'a')
                    colL[k][j][i+1] = i;
                else
                    colL[k][j][i+1] = colL[k][j][i];
            }

        for (int i = n - 1; i > 0; i--)
            for (int j = 0; j < m; j++) {
                if (v[i][j] != k + 'a')
                    colR[k][j][i-1] = i;
                else
                    colR[k][j][i-1] = colR[k][j][i];
            }
    }
    int q; scanf("%d", &q);
    for (int i = 0; i < q; i++) {
        int a, b; scanf("%d%d", &a, &b); a--, b--;
        int ax = -1, ay = -1, ansC = 2345678;
        for (int k = 0; k < 26; k++) {
            int nx1 = rowL[k][a][b];
            int nx2 = rowR[k][a][b];
            int nx;
            if (abs(b - nx1) < abs(b - nx2))
                nx = nx1;
            else
                nx = nx2;
            int ny1 = colL[k][b][a];
            int ny2 = colR[k][b][a];
            int ny;
            if (abs(a - ny1) < abs(a - ny2))
                ny = ny1;
            else
                ny = ny2;
            int tmp = abs(nx - b) + abs(ny - a);
            if (tmp < ansC) {
                ax = nx;
                ay = ny;
                ansC = tmp;
            }
        }
        if (ax < 0 || ay < 0) {
            printf("%d\n", -1);
        } else {
            printf("%d %d %d %d\n", a+1, ax+1, ay+1, b+1);
        }
    }
    return 0;
}
