#include <iostream>
#include <algorithm>

using namespace std;

const int maxN = 20000000;

int sieve[maxN] = {};

void doSieve() {
    for (int i = 1; i < maxN; i++)
        sieve[i] = i;
    for (int i = 2; i * i < maxN; i++)
        if (sieve[i] == i)
            for (int j = i + i; j < maxN; j += i)
                sieve[j] = min(sieve[j], i);
}

inline int cnt(int x) {
    if (x == 1) return 1;
    int ans = 1, cur = 1, curMul = 1;
    while (x != 1) {
        int nxt = sieve[x];
        x /= nxt;
        if (nxt == cur) {
            curMul++;
        } else {
            ans *= curMul;
            cur = nxt;
            curMul = 2;
        }
    }
    ans *= curMul;
    return ans;
}

int main() {
    doSieve();
    long long n; cin >> n;
    if (n >= 12012000) {
        cout << (n + 120119) / 120120 * 120120 << endl;
        return 0;
    }
    for (int x = n; 100LL * x <= 101LL * n; x++)
        if (cnt(x) >= 100) {
            cout << x << endl;
            return 0;
        }
    cout << -1 << endl;
    return 0;
}
