#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 5e5 + 227 + 1;
const int inf = 2e9;
//const int INFINT = 1e9 + 227 + 1;
//const long long INF = 1e18 + 227 + 1;
const int MOD = (int)1e9 + 7;

#define all(a) (a).begin(), (a).end()
#define f first
#define ll long long
#define s second
#define pb push_back
#define mp make_pair

template <typename T>
T next_int() {
    T ans = 0, t = 1;
    char ch;
    do {ch = getchar(); } while(ch <= ' ') ;
    if(ch == '-') {
        t = -1;
        ch = getchar();
    }
    while(ch > ' ') {
        ans = ans * 10 + (ch - '0');
        ch = getchar();
    }
    return ans * t;
}

char* a[MAXN];

int main() {
    ios::sync_with_stdio(0);
//    freopen(".in", "r", stdin);
//    freopen(".in", "r", stdin);
//    freopen(".out", "w", stdout);

    int n, m;
    scanf("%d %d\n", &n, &m);
    for  (int i = 0; i < n; i++)
        a[i] = new char[m + 5];

    for (int i = 0; i < n; i++) {
        gets(a[i]);
        for (int j = 0; j < m; j++)
            a[i][j] -= 'a';
    }
    vector<vector<vector<int> > > up(n, vector<vector<int> >(m, vector<int>(26))), dw, lf, rf;
    dw = up;
    lf = up;
    rf = up;

    for (int j = 0; j < m; j++) {
        for (int k = 0; k < 26; k++) {
            up[0][j][k] = inf;
            dw[n - 1][j][k] = inf;
        }
    }

    for (int i = 0; i < n; i++)
        for (int k = 0; k < 26; k++) {
            lf[i][0][k] = inf;
            rf[i][m - 1][k] = inf;
        }

    for (int i = 1; i < n; i++) {
        for (int j = 0; j < m; j++)
            for (int k = 0; k < 26; k++) {
                if (a[i - 1][j] != k)
                    up[i][j][k] = 1;
                else
                    up[i][j][k] = min(inf, up[i - 1][j][k] + 1);
            }
    }

    for (int i = n - 2; i >= 0; i--) {
        for (int j = 0; j < m; j++)
            for (int k = 0; k < 26; k++) {
                if (a[i + 1][j] != k)
                    dw[i][j][k] = 1;
                else
                    dw[i][j][k] = min(inf, dw[i + 1][j][k] + 1);
            }
    }

    for (int j = 1; j < m; j++)
        for (int i = 0; i < n; i++)
            for (int k = 0; k < 26; k++) {
                if (a[i][j - 1] == k)
                    lf[i][j][k] = 1;
                else
                    lf[i][j][k] = min(inf, lf[i][j - 1][k] + 1);
            }

    for (int j = m - 2; j >= 0; j--)
        for (int i = 0; i < n; i++)
            for (int k = 0; k < 26; k++) {
                if (a[i][j + 1] == k)
                    rf[i][j][k] = 1;
                else
                    rf[i][j][k] = min(inf, rf[i][j + 1][k] + 1);
            }
    int q;
    scanf("%d\n", &q);

    while (q--) {
        int x, y;
        x = next_int<int>();
        y = next_int<int>();
        x--, y--;
//        cout << x << ' ' << y;
//    return 0;

        pair<int, pair<int, int> > ans;
        ans.f = inf;

        for (int k = 0; k < 26; k++) {
            int alpha = lf[x][y][k];
            int beta = up[x][y][k];

            if (alpha == inf || beta == inf)
                continue;
            ans = min(ans, mp(alpha + beta, mp(0, alpha)));
        }

        for (int k = 0; k < 26; k++) {
            int alpha = lf[x][y][k];
            int beta = dw[x][y][k];

            if (alpha == inf || beta == inf)
                continue;
            ans = min(ans, mp(alpha + beta, mp(1, alpha)));
        }


        for (int k = 0; k < 26; k++) {
            int alpha = rf[x][y][k];
            int beta = up[x][y][k];

            if (alpha == inf || beta == inf)
                continue;
            ans = min(ans, mp(alpha + beta, mp(2, alpha)));
        }

        for (int k = 0; k < 26; k++) {
            int alpha = rf[x][y][k];
            int beta = dw[x][y][k];

            if (alpha == inf || beta == inf)
                continue;
            ans = min(ans, mp(alpha + beta, mp(3, alpha)));
        }

        if (ans.first == inf) {
            puts("-1");
            continue;
        }

        int type = ans.s.f;
        int alpha = ans.s.s;
        int beta = ans.f - alpha;

        if (type == 0) {
            int r1 = x - beta;
            int c2 = y - alpha;

            printf("%d %d %d %d\n", r1 + 1, y + 1, x + 1, c2 + 1);
        }
        if (type == 1) {
            int r1 = x + beta;
            int c2 = y - alpha;

            printf("%d %d %d %d\n", r1 + 1, y + 1, x + 1, c2 + 1);
        }
        if (type == 2) {
            int r1 = x - beta;
            int c2 = y + alpha;

            printf("%d %d %d %d\n", r1 + 1, y + 1, x + 1, c2 + 1);
        }
        if (type == 3) {
            int r1 = x + beta;
            int c2 = y + alpha;

            printf("%d %d %d %d\n", r1 + 1, y + 1, x + 1, c2 + 1);
        }
    }
    return 0;
}
