#include <string>
#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>

using namespace std;

const int INF = 1e9;

vector <vector <char> > c;
vector <vector <int> > u, d, l, r;
int n, m;

void resize(vector <vector <int> > &g, int x, int y) {
	g.resize(x);
	for (int i = 0; i < x; i++)
		g[i].resize(y);
}

struct Ans {
	int x1, y1, x2, y2, c;
	Ans(int x1 = 0, int y1 = 0, int x2 = INF, int y2 = INF):
		x1(x1), y1(y1), x2(x2), y2(y2), c(abs(x1 - x2) + abs(y1 - y2)) {}
};

bool operator <(Ans a, Ans b) {
	return a.c < b.c;
}

bool check(int x, int y) { return x >= 0 && y >= 0 && x < n && y < m; }

Ans get(int x, int y, vector <vector <int> > &e1, vector <vector <int> > &e2, int dx, int dy) {
	if (!check(x + dx, y + dy))
		return Ans();
	if (e1[x][y] == -1 && e2[x][y] == -1)
		return Ans();
	if (e1[x][y] == -1)
		return Ans(x, e2[x][y], x + dx, y);
	else if (e2[x][y] == -1)
		return Ans(e1[x][y], y, x, y + dy);
	if (abs(e1[x][y] - x) != 1 && abs(e2[x][y] - y) != 1)
		return min(Ans(e1[x][y], y, x, y + dy), Ans(x, e2[x][y], x + dx, y));
	if (abs(e1[x][y] - x) != 1 || abs(e2[x][y] - y) != 1)
		return Ans(x, y + dy, x + dx, y);
	else {
		if (c[x + dx][y] != c[x][y + dy])
			return Ans(x, y + dy, x + dx, y);
		int nx = e1[x + dx][y];
		int ny = e2[x][y + dy];
		if (nx == -1 && ny == -1)
			return Ans();
		if (nx == -1)
			return Ans(x + dx, y, x, ny);
		if (ny == -1)
			return Ans(nx, y, x, y + dy);
		return min(Ans(nx, y, x, y + dy), Ans(x + dx, y, x, ny));
	}
}

long main() {
	//freopen("TEST.txt", "r", stdin);

	//cin >> n >> m;
	scanf("%d%d\n", &n, &m);
	c.resize(n);
	for (int i = 0; i < n; i++)
		c[i].resize(m);
	resize(u, n, m);
	resize(d, n, m);
	resize(l, n, m);
	resize(r, n, m);
	for (int i = 0; i < n; i++) {
   		for (int j = 0; j < m; j++)
			scanf("%c", &c[i][j]);
		scanf("\n");
	}
    
	for (int i = 0; i < n; i++)
		l[i][0] = -1, r[i][m - 1] = -1;
	for (int i = 0; i < n; i++)
		for (int j = 1; j < m; j++) {
		    l[i][j] = l[i][j - 1];
			if (c[i][j] != c[i][j - 1])
				l[i][j] = j - 1;
		}
	for (int i = 0; i < n; i++)
		for (int j = m - 2; j >= 0; j--) {
		    r[i][j] = r[i][j + 1];
			if (c[i][j] != c[i][j + 1])
				r[i][j] = j + 1;
		}
	for (int j = 0; j < m; j++)
		u[0][j] = -1, d[n - 1][j] = -1;
	for (int i = 1; i < n; i++)
		for (int j = 0; j < m; j++) {
		    u[i][j] = u[i - 1][j];
			if (c[i][j] != c[i - 1][j])
				u[i][j] = i - 1;
		}
	for (int i = n - 2; i >= 0; i--)
		for (int j = 0; j < m; j++) {
    		d[i][j] = d[i + 1][j];
			if (c[i][j] != c[i + 1][j])
				d[i][j] = i + 1;
		}

	int k; //cin >> k;
	scanf("%d", &k);
	for (int kek = 0; kek < k; kek++) {
		int x, y; //cin >> x >> y;
		scanf("%d%d", &x, &y);
		x--, y--;

		Ans q = get(x, y, u, l, -1, -1);
		Ans w = get(x, y, u, r, -1, 1);
		Ans e = get(x, y, d, l, 1, -1);
		Ans f = get(x, y, d, r, 1, 1);

		Ans answer = min(min(q, w), min(e, f));

		if (answer.c >= INF)
			printf("-1\n");
		else
			printf("%d %d %d %d\n", answer.x1 + 1, answer.y1 + 1, answer.x2 + 1, answer.y2 + 1);
	}
    
	return 0;
}